<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>UCMContentProvider xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/ucm/core/provider/UCMContentProvider.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2017 CEA LIST and Thales</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *    Ansgar Radermacher - initial API and implementation </em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *   </em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.ucm.core.provider;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EClass;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.resource.Resource;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.resource.ResourceSet;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.widgets.providers.AbstractStaticContentProvider;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.widgets.providers.IStaticContentProvider;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.StereotypeUtil;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Dependency;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Profile;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.resource.UMLResource;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <em class="jxr_javadoccomment"> * Similar to Papyrus MetaClassContentProvider: filter elements based on wanted meta-classes</em>
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment"> * but only navigate to packages, if there is a</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment"> * dependency to it.</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment"> * @author ansgar</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/ucm/core/provider/UCMContentProvider.html">UCMContentProvider</a> <strong class="jxr_keyword">extends</strong> AbstractStaticContentProvider <strong class="jxr_keyword">implements</strong> IStaticContentProvider {
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/ucm/core/provider/UCMContentProvider.html">UCMContentProvider</a>(Package rootPkg, EClass metaClass) {
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  		<strong class="jxr_keyword">this</strong>(rootPkg, metaClass, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  	}
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/ucm/core/provider/UCMContentProvider.html">UCMContentProvider</a>(Package rootPkg, EClass metaClass, Class&lt;? <strong class="jxr_keyword">extends</strong> EObject&gt; stereoAppFilter) {
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  		<strong class="jxr_keyword">this</strong>.rootPkg = rootPkg;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  		<strong class="jxr_keyword">this</strong>.metaClass = metaClass;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  		<strong class="jxr_keyword">this</strong>.stereoApp = stereoAppFilter;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  	}
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  	<strong class="jxr_keyword">protected</strong> Package rootPkg;
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  	<strong class="jxr_keyword">protected</strong> EClass metaClass;
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  	@Override
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  	<strong class="jxr_keyword">public</strong> Object[] getElements() {
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  		List&lt;Element&gt; results = <strong class="jxr_keyword">new</strong> ArrayList&lt;Element&gt;();
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  		List&lt;Package&gt; visitedPkgs = <strong class="jxr_keyword">new</strong> ArrayList&lt;Package&gt;();
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  		<strong class="jxr_keyword">if</strong> (rootPkg.eResource() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  			<em class="jxr_comment">// search in all resources, see Bug 522365 ... definition list is empty</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  			ResourceSet rs = rootPkg.eResource().getResourceSet();
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  			<strong class="jxr_keyword">for</strong> (Resource resource : rs.getResources()) {
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  				<strong class="jxr_keyword">if</strong> (resource instanceof UMLResource) {
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  					<strong class="jxr_keyword">if</strong> (resource.getContents().size() &gt; 0) {
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  						EObject topLevelElem = resource.getContents().get(0);
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  						<em class="jxr_comment">// look into packages, but not profiles</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  						<strong class="jxr_keyword">if</strong> (topLevelElem instanceof Package &amp;&amp; !(topLevelElem instanceof Profile)) {
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  							getElements(rootPkg, results, visitedPkgs);
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  						}
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  					}
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  				}
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  			}
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  		}
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  			getElements(rootPkg, results, visitedPkgs);
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  		}
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		<strong class="jxr_keyword">return</strong> results.toArray();
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  	}
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> getElements(Package pkg, List&lt;Element&gt; results, List&lt;Package&gt; visitedPkgs) {
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		<strong class="jxr_keyword">if</strong> (!visitedPkgs.contains(pkg)) {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  			visitedPkgs.add(pkg);
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  			<strong class="jxr_keyword">for</strong> (Element el : pkg.getPackagedElements()) {
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  				<strong class="jxr_keyword">if</strong> (el instanceof Dependency) {
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  					Dependency dep = (Dependency) el;
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  					<strong class="jxr_keyword">if</strong> (dep.getTargets().size() &gt; 0 &amp;&amp; (dep.getTargets().get(0) instanceof Package)) {
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  						getElements((Package) dep.getTargets().get(0), results, visitedPkgs);
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  					}
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  				}
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  				<strong class="jxr_keyword">if</strong> (el instanceof Package) {
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  					getElements((Package) el, results, visitedPkgs);
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  				}
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  				<strong class="jxr_keyword">if</strong> (metaClass.isInstance(el)) {
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  					<strong class="jxr_keyword">if</strong> (stereoApp != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  						<strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(el, stereoApp)) {
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  							results.add(el);
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  						}
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  					} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 						results.add(el);
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 					}
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 				}
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 			}
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		}
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 	}
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 	Class&lt;? <strong class="jxr_keyword">extends</strong> EObject&gt; stereoApp;
<a class="jxr_linenumber" name="L108" href="#L108">108</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
